﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=4
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private nativeMe As JavaObject
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me

End Sub


'Pass the image that contains the barcode to be decoded
Public Sub decodeBarcode(img As Image) As String
	
	Return nativeMe.RunMethod("decodeBarCode", Array(img))

End Sub
	

#If Java

import java.awt.image.BufferedImage;
import javafx.scene.image.Image;
import javafx.embed.swing.SwingFXUtils;

import com.google.zxing.*;
import com.google.zxing.client.j2se.BufferedImageLuminanceSource;
import com.google.zxing.common.HybridBinarizer;
import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
	
	
	public String decodeBarCode(Image img) {
		String decodedText = "";
		BufferedImage bmp = SwingFXUtils.fromFXImage(img, null);	
        try {
            decodedText = decodeQRCode(bmp);
            if(decodedText == null) {
                decodedText = "No barcode found in the image";
            } else {
             }
        } catch (IOException e) {
            decodedText = "Could not decode QR Code, IOException :: " + e.getMessage();
        }
		return decodedText;
    }
	
    private String decodeQRCode(BufferedImage bufferedImage) throws IOException {
        LuminanceSource source = new BufferedImageLuminanceSource(bufferedImage);
        BinaryBitmap bitmap = new BinaryBitmap(new HybridBinarizer(source));

        try {
            Result result = new MultiFormatReader().decode(bitmap);
            return result.getText();
        } catch (NotFoundException e) {
            System.out.println("There is no barcode in the image");
            return null;
        }
    }
	
#End If


